* MAINTAINERS: Add rx to target ISA section.
[deliverable/binutils-gdb.git] / gdb / cc-with-index.sh
CommitLineData
ea65fe05
DE
1#! /bin/sh
2# Wrapper around gcc to add the .gdb_index section when running the testsuite.
3
0b302171 4# Copyright (C) 2010-2012 Free Software Foundation, Inc.
ea65fe05
DE
5# This program is free software; you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation; either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
18# This program requires gdb and objcopy in addition to gcc.
0b5574da
DE
19# The default values are gdb from the build tree and objcopy from $PATH.
20# They may be overridden by setting environment variables GDB and OBJCOPY
ea65fe05
DE
21# respectively.
22# We assume the current directory is either $obj/gdb or $obj/gdb/testsuite.
23#
24# Example usage:
25#
26# bash$ cd $objdir/gdb/testsuite
27# bash$ runtest \
28# CC_FOR_TARGET="/bin/sh $srcdir/cc-with-index.sh gcc" \
29# CXX_FOR_TARGET="/bin/sh $srcdir/cc-with-index.sh g++"
30#
31# For documentation on index files: info -f gdb.info -n "Index Files"
32
33myname=cc-with-index.sh
34
35if [ -z "$GDB" ]
36then
37 if [ -f ./gdb ]
38 then
39 GDB="./gdb"
40 elif [ -f ../gdb ]
41 then
42 GDB="../gdb"
b8e9bd6c
DE
43 elif [ -f ../../gdb ]
44 then
45 GDB="../../gdb"
ea65fe05
DE
46 else
47 echo "$myname: unable to find usable gdb" >&2
48 exit 1
49 fi
50fi
51
52OBJCOPY=${OBJCOPY:-objcopy}
53
54have_link=unknown
55next_is_output_file=no
00e14314 56output_file=a.out
ea65fe05
DE
57
58for arg in "$@"
59do
60 if [ "$next_is_output_file" = "yes" ]
61 then
62 output_file="$arg"
63 next_is_output_file=no
64 continue
65 fi
66
67 # Poor man's gcc argument parser.
68 # We don't need to handle all arguments, we just need to know if we're
69 # doing a link and what the output file is.
70 # It's not perfect, but it seems to work well enough for the task at hand.
71 case "$arg" in
72 "-c") have_link=no ;;
73 "-E") have_link=no ;;
74 "-S") have_link=no ;;
75 "-o") next_is_output_file=yes ;;
76 esac
77done
78
79if [ "$next_is_output_file" = "yes" ]
80then
81 echo "$myname: Unable to find output file" >&2
82 exit 1
83fi
84
85if [ "$have_link" = "no" ]
86then
87 "$@"
88 exit $?
89fi
90
91index_file="${output_file}.gdb-index"
92if [ -f "$index_file" ]
93then
94 echo "$myname: Index file $index_file exists, won't clobber." >&2
95 exit 1
96fi
97
98output_dir="${output_file%/*}"
99[ "$output_dir" = "$output_file" ] && output_dir="."
100
101"$@"
102rc=$?
103[ $rc != 0 ] && exit $rc
104if [ ! -f "$output_file" ]
105then
106 echo "$myname: Internal error: $output_file missing." >&2
107 exit 1
108fi
109
110$GDB --batch-silent -nx -ex "file $output_file" -ex "save gdb-index $output_dir"
111rc=$?
112[ $rc != 0 ] && exit $rc
113
114# GDB might not always create an index. Cope.
115if [ -f "$index_file" ]
116then
117 $OBJCOPY --add-section .gdb_index="$index_file" \
118 --set-section-flags .gdb_index=readonly \
119 "$output_file" "$output_file"
120 rc=$?
121else
122 rc=0
123fi
124
125rm -f "$index_file"
126exit $rc
This page took 0.14898 seconds and 4 git commands to generate.